#include <bits/stdc++.h>
using namespace std;
int a[500005], sol[500005];
priority_queue<pair<int, int> > pq;
int main(){
    int n, k;
    scanf("%d%d", &n, &k);
    for(int i=0; i<n; ++i) scanf("%d", &a[i]);
    int d=k+1, l=0, r=0;
    for(int i=0; i<n-k; ++i){
        while(r-l<d){
            pq.push(make_pair((-1)*a[r], (-1)*r));
            //printf("%d pushuje -%d -%d\n", i, a[r], r);
            r++;
        }
        while(pq.top().second*(-1)<l){
                //printf("%d popuje %d %d\n", i, pq.top().first, pq.top().second);
                pq.pop();
        }
        int nl=(-1)*pq.top().second;
        //printf("nl je %d\n", nl);
        sol[i]=a[nl];
        d-=(nl-l);
        l=nl+1;
    }
    for(int i=0; i<n-k; ++i) printf("%d ",sol[i]);
    return 0;
}